SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes | Friends | Related Functions | List of all members
sf::String Class Reference
System module

Utility string class that automatically handles conversions between types and encodings. More...

`#include <String.hpp>`

## Public Types
typedef std::basic_string < Uint32 >::iterator | Iterator
| Iterator type. More...
typedef std::basic_string < Uint32 >::const_iterator | ConstIterator
| Constant iterator type. More...

## Public Member Functions
| String ()
| Default constructor. More...
| String (char ansiChar, const std::locale &locale=std::locale())
| Construct from a single ANSI character and a locale. More...
| String (wchar_t wideChar)
| Construct from single wide character. More...
| String (Uint32 utf32Char)
| Construct from single UTF-32 character. More...
| String (const char *ansiString, const std::locale &locale=std::locale())
| Construct from a null-terminated C-style ANSI string and a locale. More...
| String (const std::string &ansiString, const std::locale &locale=std::locale())
| Construct from an ANSI string and a locale. More...
| String (const wchar_t *wideString)
| Construct from null-terminated C-style wide string. More...
| String (const std::wstring &wideString)
| Construct from a wide string. More...
| String (const Uint32 *utf32String)
| Construct from a null-terminated C-style UTF-32 string. More...
| String (const std::basic_string< Uint32 > &utf32String)
| Construct from an UTF-32 string. More...
| String (const String &copy)
| Copy constructor. More...
| operator std::string () const
| Implicit cast operator to std::string (ANSI string) More...
| operator std::wstring () const
| Implicit cast operator to std::wstring (wide string) More...
std::string | toAnsiString (const std::locale &locale=std::locale()) const
| Convert the unicode string to an ANSI string. More...
std::wstring | toWideString () const
| Convert the unicode string to a wide string. More...
String & | operator= (const String &right)
| Overload of assignment operator. More...
String & | operator+= (const String &right)
| Overload of += operator to append an UTF-32 string. More...
Uint32 | operator[] (std::size_t index) const
| Overload of [] operator to access a character by its position. More...
Uint32 & | operator[] (std::size_t index)
| Overload of [] operator to access a character by its position. More...
void | clear ()
| Clear the string. More...
std::size_t | getSize () const
| Get the size of the string. More...
bool | isEmpty () const
| Check whether the string is empty or not. More...
void | erase (std::size_t position, std::size_t count=1)
| Erase one or more characters from the string. More...
void | insert (std::size_t position, const String &str)
| Insert one or more characters into the string. More...
std::size_t | find (const String &str, std::size_t start=0) const
| Find a sequence of one or more characters in the string. More...
const Uint32 * | getData () const
| Get a pointer to the C-style array of characters. More...
Iterator | begin ()
| Return an iterator to the beginning of the string. More...
ConstIterator | begin () const
| Return an iterator to the beginning of the string. More...
Iterator | end ()
| Return an iterator to the beginning of the string. More...
ConstIterator | end () const
| Return an iterator to the beginning of the string. More...

## Static Public Attributes
static const std::size_t | InvalidPos
| Represents an invalid position in the string. More...

## Friends
bool | operator== (const String &left, const String &right)
bool | operator< (const String &left, const String &right)

## Related Functions
(Note that these are not member functions.)
bool | operator== (const String &left, const String &right)
| Overload of == operator to compare two UTF-32 strings. More...
bool | operator!= (const String &left, const String &right)
| Overload of != operator to compare two UTF-32 strings. More...
bool | operator< (const String &left, const String &right)
| Overload of < operator to compare two UTF-32 strings. More...
bool | operator> (const String &left, const String &right)
| Overload of > operator to compare two UTF-32 strings. More...
bool | operator<= (const String &left, const String &right)
| Overload of <= operator to compare two UTF-32 strings. More...
bool | operator>= (const String &left, const String &right)
| Overload of >= operator to compare two UTF-32 strings. More...
String | operator+ (const String &left, const String &right)
| Overload of binary + operator to concatenate two strings. More...

## Detailed Description

Utility string class that automatically handles conversions between types and encodings.

sf::String is a utility string class defined mainly for convenience.

It is a Unicode string (implemented using UTF-32), thus it can store any character in the world (european, chinese, arabic, hebrew, etc.).

It automatically handles conversions from/to ANSI and wide strings, so that you can work with standard string classes and still be compatible with functions taking a sf::String.

sf::String s;
std::string s1 = s; // automatically converted to ANSI string
std::wstring s2 = s; // automatically converted to wide string
s = "hello"; // automatically converted from ANSI string
s = L"hello"; // automatically converted from wide string
s += 'a'; // automatically converted from ANSI string
s += L'a'; // automatically converted from wide string

Conversions involving ANSI strings use the default user locale. However it is possible to use a custom locale if necessary:

std::locale locale;
sf::String s;
...
std::string s1 = s.toAnsiString(locale);
s = sf::String("hello", locale);

sf::String defines the most important functions of the standard std::string class: removing, random access, iterating, appending, comparing, etc. However it is a simple class provided for convenience, and you may have to consider using a more optimized class if your program requires complex string handling. The automatic conversion functions will then take care of converting your string to sf::String whenever SFML requires it.

Please note that SFML also defines a low-level, generic interface for Unicode handling, see the sf::Utf classes.

Definition at line 43 of file String.hpp.

## Member Typedef Documentation

typedef std::basic_string<Uint32>::const_iterator sf::String::ConstIterator

Constant iterator type.

Definition at line 51 of file String.hpp.

typedef std::basic_string<Uint32>::iterator sf::String::Iterator

Iterator type.

Definition at line 50 of file String.hpp.

## Constructor & Destructor Documentation

sf::String::String | ( | ) |  |

Default constructor.

This constructor creates an empty string.

sf::String::String | ( | char | ansiChar,
|  | const std::locale & | locale = `std::locale()`
| ) |  |

Construct from a single ANSI character and a locale.

The source character is converted to UTF-32 according to the given locale.

Parameters

  ansiChar | ANSI character to convert
  locale | Locale to use for conversion

sf::String::String | ( | wchar_t | wideChar) |  |

Construct from single wide character.

Parameters

  wideChar | Wide character to convert

sf::String::String | ( | Uint32 | utf32Char) |  |

Construct from single UTF-32 character.

Parameters

  utf32Char | UTF-32 character to convert

sf::String::String | ( | const char * | ansiString,
|  | const std::locale & | locale = `std::locale()`
| ) |  |

Construct from a null-terminated C-style ANSI string and a locale.

The source string is converted to UTF-32 according to the given locale.

Parameters

  ansiString | ANSI string to convert
  locale | Locale to use for conversion

sf::String::String | ( | const std::string & | ansiString,
|  | const std::locale & | locale = `std::locale()`
| ) |  |

Construct from an ANSI string and a locale.

The source string is converted to UTF-32 according to the given locale.

Parameters

  ansiString | ANSI string to convert
  locale | Locale to use for conversion

sf::String::String | ( | const wchar_t * | wideString) |  |

Construct from null-terminated C-style wide string.

Parameters

  wideString | Wide string to convert

sf::String::String | ( | const std::wstring & | wideString) |  |

Construct from a wide string.

Parameters

  wideString | Wide string to convert

sf::String::String | ( | const Uint32 * | utf32String) |  |

Construct from a null-terminated C-style UTF-32 string.

Parameters

  utf32String | UTF-32 string to assign

sf::String::String | ( | const std::basic_string< Uint32 > & | utf32String) |  |

Construct from an UTF-32 string.

Parameters

  utf32String | UTF-32 string to assign

sf::String::String | ( | const String & | copy) |  |

Copy constructor.

Parameters

  copy | Instance to copy

## Member Function Documentation

Iterator sf::String::begin | ( | ) |  |

Return an iterator to the beginning of the string.

Returns
  Read-write iterator to the beginning of the string characters

See Also
  end

ConstIterator sf::String::begin | ( | ) |  | const

Return an iterator to the beginning of the string.

Returns
  Read-only iterator to the beginning of the string characters

See Also
  end

void sf::String::clear | ( | ) |  |

Clear the string.

This function removes all the characters from the string.

See Also
  isEmpty, erase

Iterator sf::String::end | ( | ) |  |

Return an iterator to the beginning of the string.

The end iterator refers to 1 position past the last character; thus it represents an invalid character and should never be accessed.

Returns
  Read-write iterator to the end of the string characters

See Also
  begin

ConstIterator sf::String::end | ( | ) |  | const

Return an iterator to the beginning of the string.

The end iterator refers to 1 position past the last character; thus it represents an invalid character and should never be accessed.

Returns
  Read-only iterator to the end of the string characters

See Also
  begin

void sf::String::erase | ( | std::size_t | position,
|  | std::size_t | count = `1`
| ) |  |

Erase one or more characters from the string.

This function removes a sequence of count characters starting from position.

Parameters

  position | Position of the first character to erase
  count | Number of characters to erase

std::size_t sf::String::find | ( | const String & | str,
|  | std::size_t | start = `0`
| ) |  | const

Find a sequence of one or more characters in the string.

This function searches for the characters of str into the string, starting from start.

Parameters

  str | Characters to find
  start | Where to begin searching

Returns
  Position of str in the string, or String::InvalidPos if not found

const Uint32* sf::String::getData | ( | ) |  | const

Get a pointer to the C-style array of characters.

This functions provides a read-only access to a null-terminated C-style representation of the string. The returned pointer is temporary and is meant only for immediate use, thus it is not recommended to store it.

Returns
  Read-only pointer to the array of characters

std::size_t sf::String::getSize | ( | ) |  | const

Get the size of the string.

Returns
  Number of characters in the string

See Also
  isEmpty

void sf::String::insert | ( | std::size_t | position,
|  | const String & | str
| ) |  |

Insert one or more characters into the string.

This function inserts the characters of str into the string, starting from position.

Parameters

  position | Position of insertion
  str | Characters to insert

bool sf::String::isEmpty | ( | ) |  | const

Check whether the string is empty or not.

Returns
  True if the string is empty (i.e. contains no character)

See Also
  clear, getSize

sf::String::operator std::string | ( | ) |  | const

Implicit cast operator to std::string (ANSI string)

The current global locale is used for conversion. If you want to explicitely specify a locale, see toAnsiString. Characters that do not fit in the target encoding are discarded from the returned string. This operator is defined for convenience, and is equivalent to calling toAnsiString().

Returns
  Converted ANSI string

See Also
  toAnsiString, operator std::wstring

sf::String::operator std::wstring | ( | ) |  | const

Implicit cast operator to std::wstring (wide string)

Characters that do not fit in the target encoding are discarded from the returned string. This operator is defined for convenience, and is equivalent to calling toWideString().

Returns
  Converted wide string

See Also
  toWideString, operator std::string

String& sf::String::operator+= | ( | const String & | right) |  |

Overload of += operator to append an UTF-32 string.

Parameters

  right | String to append

Returns
  Reference to self

String& sf::String::operator= | ( | const String & | right) |  |

Overload of assignment operator.

Parameters

  right | Instance to assign

Returns
  Reference to self

Uint32 sf::String::operator[] | ( | std::size_t | index) |  | const

Overload of [] operator to access a character by its position.

This function provides read-only access to characters. Note: this function doesn't throw if index is out of range.

Parameters

  index | Index of the character to get

Returns
  Character at position index

Uint32& sf::String::operator[] | ( | std::size_t | index) |  |

Overload of [] operator to access a character by its position.

This function provides read and write access to characters. Note: this function doesn't throw if index is out of range.

Parameters

  index | Index of the character to get

Returns
  Reference to the character at position index

std::string sf::String::toAnsiString | ( | const std::locale & | locale = `std::locale()`) |  | const

Convert the unicode string to an ANSI string.

The UTF-32 string is converted to an ANSI string in the encoding defined by locale. Characters that do not fit in the target encoding are discarded from the returned string.

Parameters

  locale | Locale to use for conversion

Returns
  Converted ANSI string

See Also
  toWideString, operator std::string

std::wstring sf::String::toWideString | ( | ) |  | const

Convert the unicode string to a wide string.

Characters that do not fit in the target encoding are discarded from the returned string.

Returns
  Converted wide string

See Also
  toAnsiString, operator std::wstring

## Friends And Related Function Documentation

bool operator!= | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of != operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if both strings are different

String operator+ | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of binary + operator to concatenate two strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  Concatenated string

bool operator< | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of < operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if left is alphabetically lesser than right

bool operator<= | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of <= operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if left is alphabetically lesser or equal than right

bool operator== | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of == operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if both strings are equal

bool operator> | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of > operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if left is alphabetically greater than right

bool operator>= | ( | const String & | left,
|  | const String & | right
| ) |  |
| related

Overload of >= operator to compare two UTF-32 strings.

Parameters

  left | Left operand (a string)
  right | Right operand (a string)

Returns
  True if left is alphabetically greater or equal than right

## Member Data Documentation

const std::size_t sf::String::InvalidPos
| static

Represents an invalid position in the string.

Definition at line 56 of file String.hpp.

The documentation for this class was generated from the following file:

- String.hpp